<template>
  <div>
    <h2>Posts page with Vuex</h2>
    <my-input :model-value="searchQuery" @update:model-value="setSearchQuery" placeholder="Search..." class="search"/>
    <div class="app__btns">
      <my-button
        @click="showDialog"
      >
        Create post
      </my-button>
      <my-select
        :model-value="selectedSort"
        @update:model-value="setSelectedSort"
        :options="sortOptions"
      />
    </div>
    <my-dialog v-model:show="dialogVisible">
      <post-form @create="createPost"/>
    </my-dialog>
    <post-list
        :posts="sortedAndSearchedPosts"
        @remove="removePost"
        v-if="!isPostsLoading"
    />
    <div v-else>Loading...</div>
    <div v-intersection="loadMorePosts" class="observer"></div>
  </div>
</template>

<script>
import PostForm from "@/components/PostForm";
import PostList from "@/components/PostList";
import MySelect from "@/components/UI/MySelect";
import {mapState, mapGetters, mapActions, mapMutations} from 'vuex'

export default {
  components: { PostList, PostForm, MySelect },
 data() {
    return {
      dialogVisible: false,
    }
  },
  methods: {
    ...mapMutations({
      setPage: 'posts/setPage',
      setSearchQuery: 'posts/setSearchQuery',
      setSelectedSort: 'posts/setSelectedSort',
    }),
    ...mapActions({
      loadMorePosts: 'posts/loadMorePosts',
      fetchPosts: 'posts/fetchPosts'
    }),
    createPost(post) {
      this.posts.push(post);
      this.dialogVisible = false;
    },
    removePost(post) {
      this.posts = this.posts.filter(p => p.id !== post.id)
    },
    showDialog() {
      this.dialogVisible = true;
    },
  },
  mounted() {
    this.fetchPosts();
  },
  computed: {
    ...mapState({
      posts: state => state.posts.posts,
      isPostsLoading: state => state.posts.isPostsLoading,
      selectedSort: state => state.posts.selectedSort,
      searchQuery: state => state.posts.searchQuery,
      page: state => state.posts.page,
      limit: state => state.posts.limit,
      totalPages: state => state.posts.totalPages,
      sortOptions: state => state.posts.sortOptions
    }),
    ...mapGetters({
      sortedPosts: 'posts/sortedPosts',
      sortedAndSearchedPosts: 'posts/sortedAndSearchedPosts'
    })
  },
}
</script>

<style scoped>
.app__btns {
  display: flex;
  justify-content: space-between;
  margin: 15px 0;
}
.search {
  width: 100%;
}
</style>

